// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> field(n, vector<int>(m));
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < m; ++j) {
			field[i][j] = s[j] == '#';
		}
	}

	int ans = 0;

	for (int rot = 0; rot < 2; ++rot) {
		vector<int> in_column(m);
		vector<int> above_row(n);
		int max_in_row = 0;
		for (int i = 0; i < n; ++i) {
			max_in_row = max(max_in_row, *max_element(in_column.begin(), in_column.end()));
			above_row[i] = max_in_row;
			int cur_in_row = 0;
			for (int j = 0; j < m; ++j) {
				if (field[i][j] == 0) {
					++in_column[j];
					++cur_in_row;
				} else {
					in_column[j] = 0;
					cur_in_row = 0;
				}
				max_in_row = max(max_in_row, cur_in_row);
			}
		}

		max_in_row = 0;
		fill(in_column.begin(), in_column.end(), 0);

		for (int i = n - 1; i >= 0; --i) {
			int cur_in_row = 0;
			for (int j = 0; j < m; ++j) {
				if (field[i][j] == 0) {
					++in_column[j];
					++cur_in_row;
				} else {
					in_column[j] = 0;
					cur_in_row = 0;
				}
				max_in_row = max(max_in_row, cur_in_row);
			}

			max_in_row = max(max_in_row, *max_element(in_column.begin(), in_column.end()));

			int under = max_in_row;

			ans = max(ans, under + above_row[i]);
		}

		vector<vector<int>> tmp(m, vector<int>(n));
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				tmp[j][i] = field[i][j];
			}
		}
		swap(n, m);
		swap(tmp, field);
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}